#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << (x) << endl
#else
#   define DEBUG(x)
#endif

void merge(int a[], int from, int mid, int to) {
    // temporary array to save the sorted array
    int tmp[to - from + 1];
    
    int i = from;
    int j = mid + 1;
    int k = 0;
    while(i <= mid && j <= to) {
        // tmp[k] is the smaller among a[i] and a[j]
        if(a[i] < a[j]) { tmp[k++] = a[i++]; }
        else { tmp[k++] = a[j++]; }
    }
    
    // copy remaining elements (only one loop is executed)
    while(i <= mid) { tmp[k++] = a[i++]; }
    while(j <= to) { tmp[k++] = a[j++]; }
    
    // copy back the sorted array
    for(int i = from; i <= to; i++) a[i] = tmp[i - from];
}

void merge_sort(int a[], int from, int to) {
    // base case: array of size 1 (already sorted)
    if(from >= to) return;
    
    // split in the middle and sort the two halves
    int mid = (from + to) / 2;
    merge_sort(a, from, mid);
    merge_sort(a, mid + 1, to);
    
    // merge the sorted arrays into a sorted array
    merge(a, from, mid, to);
}

void print(int a[], int n) {
    for(int i = 0; i < n; i++) cout << a[i] << " ";
    cout << endl;
}

int main() {
    int a[] = {14, 33, 27, 10, 35, 19, 42, 44};
    print(a, 8);
    merge_sort(a, 0, 7);
    print(a, 8);
    return 0;
}

